-- 	MoneyCheat
--		
-- 	Author: 	Silas770
-- 	Date:		24.05.2017
--		Version:	1.0 (LS17)
--		
--		Contact at NKB Modding:
--		https://nkb-modding.com/index.php/User/6877-Silas770/
-- 	Contact at Vertex Dezign:
--		http://vertexdezign.net/forum/index.php/User/2081-Silas770/
--		

print("--- loading MoneyCheat Mod by Silas770");

MoneyCheat = {};

function MoneyCheat:loadMap(name)
	self.cheatMoney = 0;
	self.isOpen = false;
	
	self.warningText = g_i18n:getText("warningText");
	
	self.gui = RafftnixGUI:new(nil, true, true);
	
	self.gui.backGroundImage = self.gui:createImage(self.gui.baseElement, 0.25, 0.25, 0.5, 0.5, "gui/background.dds");
	
	self.gui.moneyText = self.gui:createText(self.gui.baseElement, 0.39, 0.63, 0, 0, "money", 0.023, {0.22, 0.22, 0.22, 0.68});
	
	self.gui.cheatMoneyText = self.gui:createText(self.gui.baseElement, 0.435, 0.58, 0, 0, g_i18n:getText("cheatMoneyText"), 0.03, 1);
	
	self.gui.backButton = self.gui:createButton(self.gui.baseElement, 0.35, 0.34, 0.15, 0.08, g_i18n:getText("backButton"), 0.03, 1, self.close, self);
	self.gui.backButton:setTextFocus("middle", "center");
	
	self.gui.enterButton = self.gui:createButton(self.gui.baseElement, 0.5, 0.34, 0.15, 0.08, g_i18n:getText("enterButton"), 0.03, 1, self.enterCallback, self);
	self.gui.enterButton:setTextFocus("middle", "center");
	
	self.gui.textInput = self.gui:createTextInput(self.gui.baseElement, 0.505, 0.485, 0, 0, "", 0.03, 1, 10);
end;

function MoneyCheat:deleteMap()
end;

function MoneyCheat:mouseEvent(posX, posY, isDown, isUp, button)
end;

function MoneyCheat:keyEvent(unicode, sym, modifier, isDown)
end;

function MoneyCheat:update(dt)
	if self.gui.open ~= nil and self.isOpen == true then
		self.gui.moneyText:setText(tostring(math.floor(g_currentMission.missionStats.money)).." €");
		
		if InputBinding.hasEvent(InputBinding.MENU) then
			self:close();
		end;
		if InputBinding.hasEvent(InputBinding.MoneyCheat_enter) or InputBinding.hasEvent(InputBinding.MoneyCheat_enter2) then
			self:enterCallback();
		end;
			
		if self.gui.textInput.text ~= nil then
			if InputBinding.hasEvent(InputBinding.MoneyCheat_multiplier) then
				if string.len(self.gui.textInput.text) < 10 then
					local text = Utils.getNoNil(tonumber(self.gui.textInput.text), 0);
					if text ~= 0 then
						text = text * 10;
					elseif text == 0 and string.len(self.gui.textInput.text) > 0 then
						g_currentMission:showBlinkingWarning(self.warningText, 1500);
					end;
					self.gui.textInput:setText(""..tostring(text));
				end;
			end;
			if InputBinding.hasEvent(InputBinding.MoneyCheat_backspace) then
				if string.len(self.gui.textInput.text) > 0 then
					local text = Utils.getNoNil(tonumber(self.gui.textInput.text), 0);
					if text ~= 0 then
						text = math.floor(text / 10);
					elseif text == 0 and string.len(self.gui.textInput.text) > 0 then
						g_currentMission:showBlinkingWarning(self.warningText, 1500);
					end;
					self.gui.textInput:setText(""..tostring(text));
				end;
			end;
		end;
		
		if self.gui.textInput.text == "0" then
			self.gui.textInput:setText("");
		end;
	end;
	
	if InputBinding.hasEvent(InputBinding.MoneyCheat_open) then
		if g_gui.currentGui == nil and self.isOpen == false then
			if g_currentMission.controlPlayer and g_currentMission.player ~= nil and g_currentMission.controlledVehicle == nil then
				self:open();
			end;
		end;
	end;	
	
	if self.cheatMoney ~= 0 then
		if g_server ~= nil then
			g_currentMission:addSharedMoney(self.cheatMoney);
		else 
			g_client:getServerConnection():sendEvent(CheatMoneyEvent:new(self.cheatMoney));
		end;
		print("money added: "..tostring(self.cheatMoney).." €");
		self.cheatMoney = 0;
	end;
end;

function MoneyCheat:draw()
	if g_gui.currentGui == nil and self.isOpen == false then
		if g_currentMission.controlPlayer and g_currentMission.player ~= nil and g_currentMission.controlledVehicle == nil then
			g_currentMission:addHelpButtonText(g_i18n:getText("input_MoneyCheat_open"), InputBinding.MoneyCheat_open);
		end;
	end;
end;

function MoneyCheat:open()
	self.isOpen = true;
	--self.wasPaused = g_currentMission.paused;
	g_currentMission.player:lockInput(true);
	g_currentMission.player.walkingIsLocked = true;
	--g_currentMission.paused = true;
	self.gui:open();
	self.gui.moneyText:setText(tostring(math.floor(g_currentMission.missionStats.money)).." €");
end;

function MoneyCheat:close()
	self.gui:close();
	self.gui.textInput:setText("");
	g_currentMission.player:lockInput(false);
	g_currentMission.player.walkingIsLocked = false;
	--g_currentMission.paused = self.wasPaused;
	self.isOpen = false;
end;

function MoneyCheat:enterCallback()
	self.cheatMoney = Utils.getNoNil(tonumber(self.gui.textInput.text), 0);
	if self.cheatMoney == 0 and string.len(self.gui.textInput.text) > 0 then
		g_currentMission:showBlinkingWarning(self.warningText, 2000);
	end;
	self:close();
end;

addModEventListener(MoneyCheat);